<ComClass(PlugIn.ClassId, PlugIn.InterfaceId, PlugIn.EventsId)> _
Public Class PlugIn

#Region "COM GUIDs"
    ' These  GUIDs provide the COM identity for this class 
    ' and its COM interfaces. If you change them, existing 
    ' clients will no longer be able to access the class.
    Public Const ClassId As String = "a1524f94-e3ce-4438-9671-bca0c39d4532"
    Public Const InterfaceId As String = "cb83c68c-3ed9-40e2-8df2-639264b7ffbc"
    Public Const EventsId As String = "73265d4c-16b5-4b3e-bd1a-34eabbd8ae77"
#End Region

    ' A creatable COM class must have a Public Sub New() 
    ' with no parameters, otherwise, the class will not be 
    ' registered in the COM registry and cannot be created 
    ' via CreateObject.
    Public Sub New()
        MyBase.New()
    End Sub

    Public Sub DoModal(ByVal Doc As MaxIm.Document)
        Dim Image(,) As Single
        Image = Doc.ImageArray
        Dim W, H, I, J As Integer
        W = Image.GetLength(1)
        H = Image.GetLength(0)
        For I = 0 To H - 1
            For J = 0 To W - 1
                Image(I, J) = Image(I, J) + 100
            Next
        Next
        Doc.ImageArray = Image
    End Sub

    Public ReadOnly Property Name() As String
        Get
            Return "Add Constant 100 .NET"
        End Get
    End Property

End Class


